#include <stdio.h>
#include <stdlib.h>

enum stitch_type { KNIT, PURL, INCREASE, DECREASE, CO };

struct stitch {
  int right_side;
  int count;
  enum stitch_type type;
  struct stitch* next;
  struct stitch* prev;
  struct stitch* next_row;
  struct stitch* prev_row;
};

struct stitch* curr;
struct stitch* prev_row;
int i, repeat;
void make_stitch(enum stitch_type type) {
  struct stitch* new_stitch =
      (struct stitch*) malloc(sizeof(struct stitch));
  new_stitch->type = type;
  new_stitch->next_row = NULL;
  new_stitch->next = NULL;
  new_stitch->prev = curr;
  int count = 1;
  if (curr != NULL) {
    curr->next = new_stitch;
    count = curr->count + 1;
  }
  new_stitch->count = count;
  new_stitch->prev_row = prev_row;
  if (prev_row != NULL) {
    prev_row->next_row = new_stitch;
    prev_row = prev_row->prev;
  }
  curr = new_stitch;
}
void Purl() {
do {for (i=0;i<1;i++){make_stitch(PURL);}}while(prev_row!=NULL && prev_row->count!=0);
}


void Knit() {
for (i=0;i<1;i++){make_stitch(KNIT);}do {for (i=0;i<1;i++){make_stitch(KNIT);}}while(prev_row!=NULL && prev_row->count!=1);for (i=0;i<1;i++){make_stitch(KNIT);}
}

void Stockinette() {
Knit();
prev_row=curr;curr=NULL;
Purl();
}

int main(int argc, char* argv[]) {
int repeat;
struct stitch* first_stitch;
make_stitch(CO);
int i;
for (i = 1; i < 5; i++) {
make_stitch(CO);
}
first_stitch=curr;
for(repeat=0;repeat<5;repeat++){
prev_row=curr;curr=NULL;
Stockinette();prev_row=curr;}
for(repeat=0;repeat<1;repeat++){
prev_row=curr;curr=NULL;
Knit();prev_row=curr;}first_stitch=first_stitch->next_row;
if (argc > 1) {
if (!strcmp(argv[1], "--row_count")) {curr=first_stitch;i=0; while(curr!=NULL){i++; curr=curr->next_row;}printf("This pattern has %d rows.\n",i);}
if (!strcmp(argv[1], "--stitch_count")) {curr=first_stitch;if(argc > 2){repeat=atoi(argv[2]);i=0;while(curr->next_row!=NULL && i < repeat){i++;curr=curr->next_row;}}repeat=i;i=0;if(curr->next!=NULL){while(curr!=NULL){i++;curr=curr->next;}}else{i=curr->count;}printf("Row %d of this pattern has %d stitches.\n",repeat,i);}}
}
